/*
** pktcache.c 	- routines for caching of packet data
**
** Keith Zaback (krz@wcug.wwu.edu) Apr 98
*/

#include "ipxfury.h"
#include <stdlib.h>


/*
**	PKTCACHE_HASH_ENUM
*/
void pktcache_hash_enum(int bucket, PKTCACHE_ENTRY *entry)
{
	/* show the entry */
	notice("[%2d] ", bucket);
	print_ipx_addr(&entry->address, (PRINT_IPX_HOST | PRINT_IPX_PORT));
	notice("  (Used: %d)\n", entry->used);
	hexdump(entry->data, entry->data_length);
	
	/* done */

}


/*
**	PKTCACHE_HASH - hash function
*/
int pktcache_hash(PKTCACHE_ENTRY *entry)
{
	int		i, hash;
	BYTE		*ptr;
	
	/* we hash on the host:port part of the address */
	hash = 0;
	ptr = (BYTE *)&entry->address.host;	/* 6 bytes + 2 for port = 8 */
	for( i = 0; i < 8; i++ ) {
		hash += *ptr + (hash & *ptr);
		ptr++;
	}
	
	/* return hash */
	return(hash);

}



/*
**	PKTCACHE_COMPARE - compares two entrys
**
**	returns (0) if they are equal
*/
int pktcache_compare(PKTCACHE_ENTRY *e1, PKTCACHE_ENTRY *e2)
{

	/* just compare on their address portions		*/
	/* 6 bytes for host + 2 bytes for port = 8 bytes	*/
	return( memcmp(e1->address.host, e2->address.host, 8) );

}

